from typing import List, Any
import xlwt,configparser,os
from xmindparser import xmind_to_dict
#https://www.caituotuo.top/c2d10f21.html#%E8%AE%BE%E8%AE%A1%E6%80%9D%E8%B7%AF
def read_config():
    config = configparser.ConfigParser()
    path = os.getcwd()
    config_path = path + r'/config.ini'
    print(config_path)
    config.read(config_path, encoding='utf-8')
    xmind_file_name = config.get('setup', 'xmind_file')
    excel_file_name = config.get('setup', 'excel_file')
    author = config.get('setup', 'author')

    return xmind_file_name, excel_file_name, author




def resolve_path(dict_, lists, title):
    """
    通过递归取出每个主分支下的所有小分支并将其作为一个列表
    :param dict_:
    :param lists:
    :param title:
    :return:
    """
    # 去除title首尾空格
    title = title.strip()
    # 若title为空，则直接取value
    if len(title) == 0:
        concat_title = dict_["title"].strip()
    else:
        concat_title = title + "\t" + dict_["title"].strip()
    if not dict_.__contains__("topics"):
        lists.append(concat_title)
    else:
        for d in dict_["topics"]:
            resolve_path(d, lists, concat_title)


def xmind_to_excel(list_, excel_path, auth_name):
    f = xlwt.Workbook()
    # 生成单sheet的Excel文件，sheet名自取
    sheet = f.add_sheet("测试用例", cell_overwrite_ok=True)

    # 第一行固定的表头标题
    row_header = ["目录层级", "*用例名称", "用例类型", "关联需求编号", "作者", "步骤名", "前置条件", "执行步骤", "预期结果", "描述"]
    for i in range(0, len(row_header)):
        sheet.write(0, i, row_header[i])

    # 增量索引
    index = 0
    line_index = 0
    for h in range(0, len(list_)):
        lists: List[Any] = []
        #去掉第一层级
        resolve_path(list_[h], lists, "")
        # print('h', h)
        # print(lists)
        # print('\n'.join(lists))  # 主分支下的小分支
        for j in range(0, len(lists)):
            # 将主分支下的小分支构成列表
            # print(lists[j])
            temp = lists[j].replace('\t', '\\', 2)
            lists[j] = temp.split('\t')
            lists[j][0] = lists[j][0] + '\\'
            # 插入用例名称+序号
            lists[j].insert(1, '测试用例' + str(j + index + 1))
            lists[j].insert(2, '非自动化用例')
            lists[j].insert(3, '')
            lists[j].insert(4, auth_name)
            lists[j].insert(5, '步骤一')
            if len(lists[j]) == 3:
                lists[j].insert(6, '')
            # print(lists[j])

            for n in range(0, len(lists[j])):
                sheet.write(j + index + 1, n, lists[j][n])
                # 自定义内容，比如：测试点/用例标题、预期结果、实际结果、操作步骤、优先级……
                # 这里为了更加灵活，除序号、模块、功能点的标题固定，其余以【自定义+序号】命名，如：自定义1，需生成Excel表格后手动修改
                if n >= 9:
                    sheet.write(0, n + 1, "自定义" + str(n - 1))
            # 遍历完lists并给增量索引赋值，跳出for j循环，开始for h循环
            # line_index += 1
            if j == len(lists) - 1:
                index += len(lists)
    f.save(excel_path)


def run(xmind_path, config):
    # 将XMind转化成字典
    xmind_dict = xmind_to_dict(xmind_path)
    # print("将XMind中所有内容提取出来并转换成列表：", xmind_dict)
    # Excel文件与XMind文件保存在同一目录下
    if config[1] == '':
        excel_name = xmind_path.split('//')[-1].split(".")[0] + '.xls'
    else:
        excel_name = config[1]
    excel_path = os.getcwd() +'//' + excel_name
    print(excel_path)
    # print("通过切片得到所有分支的内容：", xmind_dict[0]['topic']['topics'])
    xmind_to_excel(xmind_dict[0]['topic']['topics'], excel_path,config[2])


if __name__ == '__main__':
    config_ = read_config()
    xmind_path_ = os.getcwd() +'//'+ config_[0]
    run(xmind_path_,config_)
    input('请输入ENTER退出！')